CRUD app
===========================================

Allows using basic CRUD operations for Salesforce objects (the examples are done using the Account sObject)

Installation and Usage
----------------------

Import the demo project into your workspace
Fill in all the values in /main/app/mule-app.properties

Run the project in Studio.

The project contains 5 flows that show how to use 5 basic operations for Salesforce.

Run the demo project and within the browser hit `http://localhost:8081`; the result would be a website that consists of five operations (Create Account, Delete Account, Query Account, Update Account and Upsert Account).

**Flows Information**

`crud_app_template`: This is our main flow. The result of this flow will be the rendering of our form.html.

1. `create_account`
This flow will allow you to create an account with a Name and AccountNumber you specify.

2. `query_account`
Calling this flow will bring all the accounts (fields: AccountNumber, BillingAddress, Id and Name) that have the Name field populated with the value you gave as input.

3. `update_account`
This flow allows you to update an account with a Name and AccountNumber you specify. To specify the account you want to update, you must give its Id.
Go ahead and query for the Id of an account as shown in the previous flow.

4. `upsert_account`
This flow allows you to update an existing account with a Name and AccountNumber you specify or create a new account with a Name and 
AccountNumber. To specify the account you want to update, you must give its Id. If you don't provide an Id, a new account will be created.
Go ahead and query for the Id of an account as shown in the query flow.
Pay attention to the account Id - if it exists in Salesforce then that account will be updated; if the Id isn't specified, a new account will be created.

5. `delete_account`
This flow allows you to delete an account whose Id you specify. 
Go ahead and query for the Id of an account as shown in the previous flow.

5. `find_duplicates_for_account`
This flow allows you to find the duplicates for a specified account, using the rule specified in Salesforce. 
In order to create a rule, go to *Administration Setup*, then *Duplicate Management* and *Duplicate Rules*. If there is no rule created, click *New Rule* and choose *Account*. Here you can customize the Rule details. Finish by clicking the *Save* button.

